unit hiMenuEx;

interface

{$I share.inc}

uses Windows,Kol,Share,Debug,Messages,XPMenus;

type
   THIMenuEx = class(TDebug)
   private
   Old:TOnMessage;
   Form:PControl;
   _Arr:PArray;

   procedure SetItems(const Value : string);
   procedure SetBitmaps(const Value : PStrListEx);
   procedure SetLineColor(const Color : integer);
   procedure SetSelectedColor(const Color : integer);
   procedure SetBackColor(const Color : integer);
   procedure SetFont(const F : TFontRec);
   procedure _OnMenuItem(Sender:PMenu;ItemIdx:integer);
   function ClearSpecSymbol(const Str:string; const Ch:string):string;
   procedure _Set(var Item:TData; var Val:TData);
   function _Get(Var Item:TData; var Val:TData):boolean;
   function _Count:integer;
   procedure _Add(var Val:TData);
   procedure _Destroy(fObject : PObj);
   function _OnMessage( var Msg: TMsg; var Rslt: Integer ): Boolean;
 public
   MenuEx:PXPMenu;


   _prop_ITemHeight : integer;

   _event_onMenuItemIdx:THI_Event;
   _event_onMenuItemName:THI_Event;
   _event_onKeyDown:THI_Event;
   _event_onSelectItem:THI_Event;
   _event_OnRightMouse:THI_Event;

   _data_Bitmaps:THI_Event;

    constructor Create(Parent:PControl);
    destructor Destroy; override;
    property _prop_Menu:string write SetItems;
    property _prop_Bitmaps:PStrListEx write SetBitmaps;
    property _prop_LineColor:TColor write SetLineColor;
    property _prop_SelectedColor:TColor write SetSelectedColor;
    property _prop_BackColor:TColor write SetBackColor;
    property _prop_Font:TFontRec write SetFont;
    procedure _work_doCheck(var _Data:TData; Index:word);
    procedure _work_doHighlight(var _Data:TData; Index:word);
    procedure _work_doVisible(var _Data:TData; Index:word);
    procedure _work_doEnable(var _Data:TData; Index:word);
    procedure _work_doBackColor(var _Data:TData; Index:word);
    procedure _work_doRefreshBitmaps(var _Data:TData; Index:word);
    procedure _work_doSelectedColor(var _Data:TData; Index:word);
    procedure _work_doLineColor(var _Data:TData; Index:word);
    procedure _work_doFont(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_Array(var _Data:TData; Index:word);
 end;

implementation

constructor THIMenuEx.Create;
begin
   inherited Create;
   Form := Parent;
   Old := Form.OnMessage;
   Form.OnMessage := _OnMessage;
end;

destructor THIMenuEx.Destroy;
begin
   Form.OnMessage := Old;
   //Form.Menu := 0;
   //MenuEx.Free;
   inherited;
end;

function THIMenuEx._OnMessage;
var cur:byte;
begin
case Msg.message of
 WM_MENUCHAR:
  _hi_OnEvent(_event_onKeyDown,LOWORD(Msg.wParam));
 WM_MENUSELECT:
 begin
 cur := LOWORD(Msg.wParam);
 _hi_OnEvent(_event_onSelectItem,cur);
 end;
 WM_CONTEXTMENU:_hi_OnEvent(_event_OnRightMouse,Cur);
end;
 Result := Old(Msg,Rslt);
end;

procedure THIMenuEx._Destroy;
begin

end;

{$ifdef F_P}
 var ListMenu: array[0..50] of PChar;
{$endif}

procedure THIMenuEx.SetItems;
var i,b,p:integer;
    vc,kc :byte;
    str,s,vs:string;
    List:PStrList;
    ListMenuStr: array  of string;
    {$ifndef F_P}
    ListMenu: array of PChar;
    {$endif}
begin
List := NewStrList;
List.text := Value;
if List.Count > 0 then
begin
  SetLength(ListMenuStr,List.Count);
  {$ifndef F_P}
  SetLength(ListMenu,List.Count);
  {$endif}
 for i := 0 to List.Count-1 do
  begin
  ListMenuStr[i] := List.Items[i];
  ListMenu[i] := PChar(@ListMenuStr[i][1]);
  end;
MenuEx := NewXPMenu(Form,0,ListMenu,_OnMenuItem,false);
MenuEx.DrawXPStyle;
 end;
end;

procedure THIMenuEx.SetLineColor;
begin
if assigned(MenuEx) then
MenuEx.GutterColor := Color;
end;

procedure THIMenuEx.SetBackColor;
begin
if assigned(MenuEx) then
MenuEx.BackColor := Color;
end;

procedure THIMenuEx.SetSelectedColor;
begin
if assigned(MenuEx) then
MenuEx.SelectedColor := Color;
end;

procedure THIMenuEx.SetFont;
function HiAsmFont2KolFont(_f : TFontRec):PGraphicTool;
begin
 Result := NewFont;
 Result.Color := _f.Color;
 Share.SetFont(Result,_f.Style);
 Result.FontName :=  _f.Name;
 Result.FontHeight := 6 + _f.Size;
 Result.FontCharset := _f.CharSet;
end;
begin
if assigned(MenuEx) then
MenuEx.Font :=  HiAsmFont2KolFont(f);
end;

procedure THIMenuEx.SetBitmaps;
var i:byte;
begin
if assigned(Value) then
for i:=0 to Value.Count-1 do
 if (Value.Objects[i] > 0) then
 MenuEx.Items[i].Bitmap:=Value.Objects[i];
end;

procedure THIMenuEx._OnMenuItem;
begin
_hi_OnEvent(_event_onMenuItemName,MenuEx.Items[ItemIdx].Caption);
_hi_OnEvent(_event_onMenuItemIdx,ItemIdx);
end;

procedure THIMenuEx._work_doCheck;
var ind:integer;
    s:PChar;
begin
ind:=ToInteger(_Data);
if MenuEx.ItemChecked[ind] then
MenuEx.ItemChecked[ind]:=false
else
MenuEx.ItemChecked[ind]:=true;
end;

procedure THIMenuEx._work_doHighlight;
var ind:integer;
begin
ind:=ToInteger(_Data);
if MenuEx.Items[ind].Highlight then
MenuEx.Items[ind].Highlight:=false
else
MenuEx.Items[ind].Highlight:=true;
end;

procedure THIMenuEx._work_doVisible;
var ind:integer;
begin
ind:=ToInteger(_Data);
if MenuEx.ItemVisible[ind] then
MenuEx.ItemVisible[ind]:=false
else
MenuEx.ItemVisible[ind]:=true;
end;

procedure THIMenuEx._work_doEnable;
var ind:integer;
begin
ind:=ToInteger(_Data);
if MenuEx.ItemEnabled[ind] then
MenuEx.ItemEnabled[ind]:=false
else
MenuEx.ItemEnabled[ind]:=true;
end;

procedure THIMenuEx._work_doRefreshBitmaps;
var Arr:PArray;
    dt,Ind:TData;
    i : byte;
    bmp : kol.PBitmap;
begin
 Arr := ReadArray(_data_Bitmaps);
  if (Arr <> nil) and (Arr._Count > 0) then
   for i := 0 to Arr._Count-1 do begin
    if i > MenuEx.Count-1 then exit;
    Ind := _DoData(i);
    Arr._Get(Ind,dt);
    bmp := PBitmap(dt.idata);
     if(dt.data_type = data_bitmap)and( bmp <> nil ) then
      begin
        if bmp.handle = 0 then
         MenuEx.Items[i].Bitmap:= 0
        else begin
         BmpTransparent(bmp);
         MenuEx.Items[i].Bitmap:= bmp.handle;
        end;
      end;
   end;
end;

procedure THIMenuEx._work_doLineColor;
begin
  MenuEx.GutterColor := ToInteger(_Data);
end;

procedure THIMenuEx._work_doSelectedColor;
begin
  MenuEx.SelectedColor := ToInteger(_Data);
end;

procedure THIMenuEx._work_doBackColor;
begin
   MenuEx.BackColor := ToInteger(_Data);
end;

procedure THIMenuEx._work_doFont;
begin
   if _IsFont(_Data) then
     SetFont(ToFont(_data)^);
end;

function THIMenuEx.ClearSpecSymbol(const Str:string; const Ch:string):string;
var i:byte;
begin
  result:='';
  for i := 1 to length(Str) do
   if Str[i]<>Ch then 
     result := result + Str[i];
end;

procedure THIMenuEx._var_Count;
begin
   dtInteger(_Data,MenuEx.Count);
end;

procedure THIMenuEx._Set(var Item:TData; var Val:TData);
var ind:integer;
begin
  ind := ToInteger(Item);
  if(ind >= 0 )and(ind < MenuEx.Count )then
   MenuEx.Items[ind].Caption := ToString(Val);
end;

function THIMenuEx._Get(Var Item:TData; var Val:TData):boolean;
var ind:integer;
begin
  ind := ToInteger(Item);
  if(ind >= 0 )and(ind < MenuEx.Count )then
    dtString(Val,MenuEx.Items[ind].Caption)
  else dtNull(val);
  Result := not _IsNull(val);
end;

function THIMenuEx._Count:integer;
begin
   Result := MenuEx.Count;
end;

procedure THIMenuEx._Add;
var sdt:string;
begin
  sdt := ToString(Val);
  if sdt = '-' then 
     MenuEx.AddItem('-',nil,[moSeparator])
  else MenuEx.Items[0].AddItem(PChar(sdt),nil,[]);
end;

procedure THIMenuEx._var_Array;
begin
   if _arr = nil then
     _Arr := CreateArray(_Set,_Get,_Count,_Add);
   dtArray(_Data,_Arr);
end;

end.
