unit hiRichEdit;

interface

uses Kol,Share,WinList,Windows,Messages;

type
  THIRichEdit = class(THIWinList)
   private

    procedure _OnChange(Obj:PObj);
    procedure SetStrings(const Value:string); override;
   public
    _prop_ScrollBars:byte;
    _prop_ReadOnly:byte;
    _prop_Strings:string;
    _prop_Caret:integer;

    _data_FileName:THI_Event;
    _data_Color:THI_Event;
    _data_Style:THI_Event;

    _event_onActivate:THI_Event;
    _event_onDeactivate:THI_Event;

    procedure _var_TextColor(var _Data:TData; Index:word);
    procedure _var_RichEdit(var _Data:TData; Index:word);

    destructor Destroy;
    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doAddBitmap(var _Data:TData; Index:word);
    procedure _work_doUndo(var _Data:TData; Index:word);
    procedure _work_doTextStyle(var _Data:TData; Index:word);
    procedure Init; override;
  end;

implementation

uses KOLOleRE;

procedure THIRichEdit._work_doLoad;
var fn:string;
    tf:TRETextFormat;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if LowerCase(ExtractFileExt(fn)) = '.rtf' then
    tf := reRTF
   else tf := reText;
   Control.RE_LoadFromFile(fn,tf,false);
end;

procedure THIRichEdit._work_doSave;
var fn:string;
    tf:TRETextFormat;
begin
   fn := ReadString(_Data,_data_FileName,_prop_FileName);
   if LowerCase(ExtractFileExt(fn)) = '.rtf' then
    tf := reRTF
   else tf := reText;
   Control.RE_SaveToFile(fn,tf,false);
end;

procedure THIRichEdit._work_doAddBitmap;
var bmp:kol.PBitmap;
   s:string;
begin
   bmp := ReadBitmap(_Data,NULL,nil);
   s := PKOLOleRichEdit(Control).BitmapToRTF(bmp);
   Control.RE_InsertRTF(s);
end;

procedure THIRichEdit._work_doAdd;
var Text:string;
    p:byte;
begin
  if _prop_AddType = 0 then
    Control.SelStart := Length(Control.Text)
  else Control.SelStart := 0;

  //debug(int2str(Control.SelStart));

  Text := ReadString(_Data,null,_prop_FileName);
  Control.RE_FmtFontColor := ReadInteger(_Data,_data_Color,0);
  p := ReadInteger(_Data,_data_Style,0);
  if p and 1 > 0 then
   Control.RE_FmtBold := true;
  if p and 2 > 0 then
   Control.RE_FmtItalic := true;
  if p and 4 > 0 then
   Control.RE_FmtUnderline := true;

  if _prop_AddType = 0 then
   begin
    if Control.Text = '' then
     Control.RE_Append(Text,true)
    else Control.RE_Append(#13#10 + Text,true);
   end
  else
    if Control.Text = '' then
     Control.RE_Append(Text,true)
    else Control.Selection := Text + #13#10;

end;

procedure THIRichEdit.SetStrings;
begin
   SendMessage(Control.Handle, WM_SETTEXT, 0, Longint(@Value[1]));
end;

procedure THIRichEdit.Init;
var Flags:TEditOptions;
begin
   Flags := [eoMultiline,eoNoHideSel,eoNoVScroll,eoNoHScroll];
   case _prop_ScrollBars of
    0: ;
    1: Exclude(Flags,eoNoHScroll);
    2: Exclude(Flags,eoNoVScroll);
    3: begin Exclude(Flags,eoNoHScroll); Exclude(Flags,eoNoVScroll); end;
   end;
   if _prop_ReadOnly = 0 then
    Include(Flags,eoReadonly);

   //Control := _NewRichEdit(FParent,Flags);
   Control := NewOLERichEdit(FParent,Flags);

   Control.OnChange := _OnChange;
   if _prop_Ctl3D = 0 then
     with Control^ do Style:= Style and not ws_BORDER;
   inherited;

   with PKOLOleRichEdit(Control)^ do
    begin
     CanDragOle := true;
     Text := _prop_Strings;
     RE_AutoURLDetect := true;
     RE_FmtStandard;
     RE_FmtAutoColor := true;
    end;
end;

destructor THIRichEdit.Destroy;
begin
   //_debug('ok');
   //PKOLOleRichEdit(Control).Destroy;
   inherited Destroy;
end;

procedure THIRichEdit._OnChange;
begin
   _hi_OnEvent(_event_onChange,Control.text);
   if _prop_Caret=0 then
   CreateCaret(Control.Handle,1,5,15);
   ShowCaret(Control.Handle);
end;

procedure THIRichEdit._work_doUndo;
begin
   SendMessage(Control.Handle, EM_UNDO, 0, 0);
end;

procedure THIRichEdit._work_doTextStyle;
var
p:integer;
begin
  Control.RE_FmtFontColor := ReadInteger(_Data,_data_Color,0);
  p := ReadInteger(_Data,_data_Style,0);
  if p and 1 > 0 then
   Control.RE_FmtBold := true;
  if p and 2 > 0 then
   Control.RE_FmtItalic := true;
  if p and 4 > 0 then
   Control.RE_FmtUnderline := true;
end;

procedure THIRichEdit._var_RichEdit;
begin
   _Data.Data_type := data_int;
   _Data.sdata := 'RichEdit';
   _Data.idata := integer(Control);
end;

procedure THIRichEdit._var_TextColor;
begin
   _Data.Data_type := data_int;
   _Data.idata :=  Control.RE_FmtFontColor ;
end;

end.
