unit hiButtonEx;

interface

uses Windows,Kol,Share,Win,KOLGRushControls;

const
  arr : array[0..6] of TGRushGradientStyle =(
   gsSolid,
   gsVertical,
   gsHorizontal,
   gsDoubleVert,
   gsDoubleHorz,
   gsFromTopLeft,
   gsFromTopRight);

{$I share.inc}

type
 ThiButtonEx = class(THIWin)
   private
     procedure _OnClick(Obj:PObj);
     procedure SetCaption(const Value:string);
   public
     _event_onClick:THI_Event;
     _prop_Data:TData;
     _prop_RoundWidth:Byte;
     _prop_RoundHeight:Byte;
     _prop_Color:Integer;

    _prop_ColorTo:Integer;
    _prop_ColorText:Integer;
    _prop_ColorFrom:Integer;
    _prop_ColorShadow:Integer;
    _prop_BorderColor:Integer;
    _prop_ShadowOffset:Integer;
    _prop_GradientStyle:Byte;

    _prop_ColorToOver:Integer;
    _prop_ColorTextOver:Integer;
    _prop_ColorFromOver:Integer;
    _prop_ColorShadowOver:Integer;
    _prop_BorderColorOver:Integer;
    _prop_ShadowOffsetOver:Integer;
    _prop_GradientStyleOver:Byte;

    _prop_ColorToDown:Integer;
    _prop_ColorTextDown:Integer;
    _prop_ColorFromDown:Integer;
    _prop_ColorShadowDown:Integer;
    _prop_BorderColorDown:Integer;
    _prop_ShadowOffsetDown:Integer;
    _prop_GradientStyleDown:Byte;

    _prop_ColorToDis:Integer;
    _prop_ColorTextDis:Integer;
    _prop_ColorFromDis:Integer;
    _prop_ColorShadowDis:Integer;
    _prop_BorderColorDis:Integer;
    _prop_ShadowOffsetDis:Integer;
    _prop_GradientStyleDis:Byte;

     constructor Create(Parent:PControl);
     procedure Init;override;
     procedure _work_doCaption(var _Data:TData; Index:word);
     property _prop_Caption:string write SetCaption;
 end;

implementation

constructor ThiButtonEx.Create;
begin
   //Parent.ExStyle := Parent.ExStyle or WS_EX_CONTROLPARENT;
   inherited Create(Parent);
   Control := NewGRushButton(Parent,'Push');
   Control.OnClick := _OnClick;
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure ThiButtonEx.Init;
begin
  inherited;
  {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
    Def_ColorText      :=  _prop_ColorText;
    Def_ColorFrom      :=  _prop_ColorFrom;
    Def_ColorShadow    :=  _prop_ColorShadow;
    Def_BorderColor    :=  _prop_BorderColor;
    Def_ColorTo        :=  _prop_ColorTo;
    Def_ShadowOffset   :=  _prop_ShadowOffset;

    Over_ColorText     :=  _prop_ColorTextOver;
    Over_ColorFrom     :=  _prop_ColorFromOver;
    Over_ColorShadow   :=  _prop_ColorShadowOver;
    Over_BorderColor   :=  _prop_BorderColorOver;
    Over_ColorTo       :=  _prop_ColorToOver;
    Over_ShadowOffset  :=  _prop_ShadowOffsetOver;

    Down_ColorText     :=  _prop_ColorTextDown;
    Down_ColorFrom     :=  _prop_ColorFromDown;
    Down_ColorShadow   :=  _prop_ColorShadowDown;
    Down_BorderColor   :=  _prop_BorderColorDown;
    Down_ColorTo       :=  _prop_ColorToDown;
    Down_ShadowOffset  :=  _prop_ShadowOffsetDown;

    Dis_ColorText      :=  _prop_ColorTextDis;
    Dis_ColorFrom      :=  _prop_ColorFromDis;
    Dis_ColorShadow    :=  _prop_ColorShadowDis;
    Dis_BorderColor    :=  _prop_BorderColorDis;
    Dis_ColorTo        :=  _prop_ColorToDis;
    Dis_ShadowOffset   :=  _prop_ShadowOffsetDis;

    Def_BorderRoundWidth   :=  _prop_RoundWidth;
    Def_BorderRoundHeight  :=  _prop_RoundHeight;
    Over_BorderRoundWidth  :=  _prop_RoundWidth;
    Over_BorderRoundHeight :=  _prop_RoundHeight;
    Down_BorderRoundWidth  :=  _prop_RoundWidth;
    Down_BorderRoundHeight :=  _prop_RoundHeight;
    Dis_BorderRoundWidth   :=  _prop_RoundWidth;
    Dis_BorderRoundHeight  :=  _prop_RoundHeight;

    All_DrawFocusRect  :=  false;
    Def_ColorOuter :=  _prop_Color;
    Over_ColorOuter := _prop_Color;
    Down_ColorOuter := _prop_Color;
    Dis_ColorOuter :=  _prop_Color;

    Def_GradientStyle  :=  arr[_prop_GradientStyle];
    Over_GradientStyle :=  arr[_prop_GradientStyleOver];
    Down_GradientStyle :=  arr[_prop_GradientStyleDown];
    Dis_GradientStyle  :=  arr[_prop_GradientStyleDis];
   end;
end;

procedure ThiButtonEx._work_doCaption;
begin
   Control.Caption := ReadString(_Data,Null,'');
end;

procedure ThiButtonEx._OnClick;
var dt:TData;
begin
   dt := _prop_Data;
  _hi_OnEvent(_event_onClick,dt);
end;

procedure ThiButtonEx.SetCaption;
begin
  Control.Caption := Value;
end;

end.
