unit hiProgressBarEx;

interface

uses Kol,Share,Win,Windows,KOLGRushControls;

const
  arr : array[0..6] of TGRushGradientStyle =(
   gsSolid,
   gsVertical,
   gsHorizontal,
   gsDoubleVert,
   gsDoubleHorz,
   gsFromTopLeft,
   gsFromTopRight);

type
  ThiProgressBarEx = class(THIWin)
   private
   public
    _prop_Smooth:boolean;
    _prop_Max:integer;
    _prop_Color:Integer;
    _prop_Kind:Boolean;
    _prop_Rect:Boolean;
    _prop_DrawProgress:Boolean;
    _prop_Caption:String;

    _prop_ColorTo:Integer;
    _prop_ColorText:Integer;
    _prop_ColorFrom:Integer;
    _prop_ColorShadow:Integer;
    _prop_BorderColor:Integer;
    _prop_ShadowOffset:Integer;
    _prop_GradientStyle:Byte;

    _prop_ColorToDis:Integer;
    _prop_ColorTextDis:Integer;
    _prop_ColorFromDis:Integer;
    _prop_ColorShadowDis:Integer;
    _prop_BorderColorDis:Integer;
    _prop_ShadowOffsetDis:Integer;
    _prop_GradientStyleDis:Byte;

    procedure Init; override;
    procedure _work_doPosition(var _Data:TData; Index:word);
    procedure _work_doMax(var _Data:TData; Index:word);
    procedure _var_Position(var _Data:TData; Index:word);
  end;

implementation

procedure ThiProgressBarEx.Init;
begin
   Control := NewGRushProgressBar(FParent);
   Control.MaxProgress := _prop_Max;
   Control.Caption := _prop_Caption;
 inherited;
   {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
    Def_ColorText      :=  _prop_ColorText;
    Def_ColorFrom      :=  _prop_ColorFrom;
    Def_ColorShadow    :=  _prop_ColorShadow;
    Def_BorderColor    :=  _prop_BorderColor;
    Def_ColorTo        :=  _prop_ColorTo;
    Def_ShadowOffset   :=  _prop_ShadowOffset;
    Def_ColorOuter     :=  _prop_Color;

    Dis_ColorText      :=  _prop_ColorTextDis;
    Dis_ColorFrom      :=  _prop_ColorFromDis;
    Dis_ColorShadow    :=  _prop_ColorShadowDis;
    Dis_BorderColor    :=  _prop_BorderColorDis;
    Dis_ColorTo        :=  _prop_ColorToDis;
    Dis_ShadowOffset   :=  _prop_ShadowOffsetDis;

    All_DrawProgress := _prop_DrawProgress;
    All_DrawProgressRect := _prop_Rect;
    All_ProgressVertical := _prop_Kind;
    Def_BorderRoundWidth := 0;
    Def_BorderRoundHeight := 0;

    Def_GradientStyle  :=  arr[_prop_GradientStyle];
    Dis_GradientStyle  :=  arr[_prop_GradientStyleDis];
   end;
end;

procedure ThiProgressBarEx._work_doPosition;
begin
   Control.Progress := ReadInteger(_data,null,0);
end;

procedure ThiProgressBarEx._work_doMax;
begin
   Control.MaxProgress := ReadInteger(_data,null,0);
end;

procedure ThiProgressBarEx._var_Position;
begin
  _Data.data_type := data_int;
  _Data.idata := Control.Progress;
end;

end.
