unit hiRadioButtonEx;

interface

uses Windows,Kol,Share,Win,Messages,KOLGRushControls;

const
  arr : array[0..6] of TGRushGradientStyle =(
   gsSolid,
   gsVertical,
   gsHorizontal,
   gsDoubleVert,
   gsDoubleHorz,
   gsFromTopLeft,
   gsFromTopRight);


{$I share.inc}
type
  ThiRadioButtonEx = class(THIWin)
   private
     procedure _OnClick(Obj:PObj);
     procedure SetCaption(const Value:string);
     procedure SetSelected(Value:byte);
   public
    _event_onSelect:THI_Event;

    _prop_ColorTo:Integer;
    _prop_ColorText:Integer;
    _prop_ColorFrom:Integer;
    _prop_ColorShadow:Integer;
    _prop_BorderColor:Integer;
    _prop_ShadowOffset:Integer;
    _prop_GradientStyle:Byte;

    _prop_ColorToOver:Integer;
    _prop_ColorTextOver:Integer;
    _prop_ColorFromOver:Integer;
    _prop_ColorShadowOver:Integer;
    _prop_BorderColorOver:Integer;
    _prop_ShadowOffsetOver:Integer;
    _prop_GradientStyleOver:Byte;

    _prop_ColorToDown:Integer;
    _prop_ColorTextDown:Integer;
    _prop_ColorFromDown:Integer;
    _prop_ColorShadowDown:Integer;
    _prop_BorderColorDown:Integer;
    _prop_ShadowOffsetDown:Integer;
    _prop_GradientStyleDown:Byte;

    _prop_ColorToDis:Integer;
    _prop_ColorTextDis:Integer;
    _prop_ColorFromDis:Integer;
    _prop_ColorShadowDis:Integer;
    _prop_BorderColorDis:Integer;
    _prop_ShadowOffsetDis:Integer;
    _prop_GradientStyleDis:Byte;

    _prop_CheckMetric:Integer;
    _prop_ColorCheck:Integer;
    _prop_Color:Integer;

    constructor Create(Parent:PControl);
    procedure Init;override;
    procedure _work_doSelect(var _Data:TData; Index:word);
    procedure _work_doCaption(var _Data:TData; Index:word);
    procedure _var_Selected(var _Data:TData; Index:word);
    property _prop_Selected:byte write SetSelected;
    property _prop_Caption:string  write SetCaption;
  end;

implementation

constructor ThiRadioButtonEx.Create;
begin
   inherited Create(Parent);
   Control := NewGRushRadiobox(Parent,'RadioButton');
   //Control.Style := Control.Style and not WS_BORDER;
   Control.OnClick := _OnClick;
   {$ifdef F_P}
   _prop_Ctl3D := 0;
   {$else}
   _prop_Ctl3D := 1;
   {$endif}
end;

procedure ThiRadioButtonEx.Init;
begin
  inherited;
  {$ifdef F_P}
  with PGRushControl(Control) do
  {$else}
  with PGRushControl(Control)^ do
  {$endif}
   begin
    Def_ColorText      :=  _prop_ColorText;
    Def_ColorFrom      :=  _prop_ColorFrom;
    Def_ColorShadow    :=  _prop_ColorShadow;
    Def_BorderColor    :=  _prop_BorderColor;
    Def_ColorTo        :=  _prop_ColorTo;
    Def_ShadowOffset   :=  _prop_ShadowOffset;

    Over_ColorText     :=  _prop_ColorTextOver;
    Over_ColorFrom     :=  _prop_ColorFromOver;
    Over_ColorShadow   :=  _prop_ColorShadowOver;
    Over_BorderColor   :=  _prop_BorderColorOver;
    Over_ColorTo       :=  _prop_ColorToOver;
    Over_ShadowOffset  :=  _prop_ShadowOffsetOver;

    Down_ColorText     :=  _prop_ColorTextDown;
    Down_ColorFrom     :=  _prop_ColorFromDown;
    Down_ColorShadow   :=  _prop_ColorShadowDown;
    Down_BorderColor   :=  _prop_BorderColorDown;
    Down_ColorTo       :=  _prop_ColorToDown;
    Down_ShadowOffset  :=  _prop_ShadowOffsetDown;

    Dis_ColorText      :=  _prop_ColorTextDis;
    Dis_ColorFrom      :=  _prop_ColorFromDis;
    Dis_ColorShadow    :=  _prop_ColorShadowDis;
    Dis_BorderColor    :=  _prop_BorderColorDis;
    Dis_ColorTo        :=  _prop_ColorToDis;
    Dis_ShadowOffset   :=  _prop_ShadowOffsetDis;

    All_CheckMetric    :=  _prop_CheckMetric;
    All_ColorCheck     :=  _prop_ColorCheck;
    All_DrawFocusRect  :=  false;
    Def_ColorOuter :=  _prop_Color;
    Over_ColorOuter := _prop_Color;
    Down_ColorOuter := _prop_Color;
    Dis_ColorOuter :=  _prop_Color;

    Def_GradientStyle  :=  arr[_prop_GradientStyle];
    Over_GradientStyle :=  arr[_prop_GradientStyleOver];
    Down_GradientStyle :=  arr[_prop_GradientStyleDown];
    Dis_GradientStyle  :=  arr[_prop_GradientStyleDis];
   end;
end;

procedure ThiRadioButtonEx._work_doSelect;
begin
   //Control.Checked := ReadBool(_Data);
   SendMessage(Control.Handle,BM_CLICK,0,0);
end;

procedure ThiRadioButtonEx._work_doCaption;
begin
   Control.Caption := ToString(_Data);
end;

procedure ThiRadioButtonEx._var_Selected;
begin
   _Data.data_type := data_int;
   _Data.idata := integer(Control.Checked);
end;

procedure ThiRadioButtonEx.SetCaption;
begin
   Control.Caption := Value;
end;

procedure ThiRadioButtonEx.SetSelected;
begin
  Control.Checked := value = 0;
end;

procedure ThiRadioButtonEx._OnClick;
begin
  _hi_OnEvent(_event_onSelect); 
end;

end.
